//
//	 1998 by Camil Demetrescu and Irene Finocchi. All Rights Reserved.
//	MatrixLib.c library
//


/**

	// Inactive definitions

	Inactive Matrix(Out 0,Out 0,Out 0,Out 0,V);
	Inactive MatrixItem(I,J,Out 0,Out 0,V);
	Inactive MatrixItemColor(I,J,Out 0,V);
	Inactive MatrixItemBackColor(I,J,Out 0,V);
	Inactive MatrixItemFace(I,J,Out 0,V);
	Inactive MatrixTitle(Out 0,V);
	
	// Array implementation
	
	#define _intmatrixL_			25
	#define _intmatrixH_			25
	#define _idxdist_				7
	#define _intmatrix_				(-15000)
	
	Rectangle(Out R,Out X,Out Y,Out _intmatrixL_+1,Out _intmatrixH_+1,V)
		For X0,Y0,N,M:Matrix(X0,Y0,N,M,V)
		For I:InRange(I,0,N-1)
		For J:InRange(J,0,M-1)
		Assign Y=Y0+I*_intmatrixH_ X=X0+J*_intmatrixL_ R=_intmatrix_+(I<<16)+J;
	
	RectangleColor(R,Out C,V)
		Assign R=R-_intmatrix_
		For C:MatrixItemBackColor(R>>16,R&0x0000FFFF,C,V);
	
	SmallText(Out _intmatrix_-1,Out X,Out Y,Out String,Out S,Out Center,V)
		For X,Y,N,M:Matrix(X,Y,N,M,V)
		If N>0 && M>0
		For S:MatrixTitle(S,V)
		Assign X=X+(M*_intmatrixL_)/2  Y=Y-20;
		
	SmallText(Out _intmatrix_-1,Out X,Out Y,Out Int,Out I,Out Right,V)
		For X0,Y0,N,M:Matrix(X0,Y0,N,M,V)
		Assign X=X0-5
		For I:InRange(I,0,N-1)
		Assign 	Y=Y0+(I+1)*_intmatrixH_-_intmatrixH_/2+5;

	SmallText(Out _intmatrix_-2,Out X,Out Y,Out Int,Out J,Out Center,V)
		For X0,Y0,N,M:Matrix(X0,Y0,N,M,V)
		Assign Y=Y0-5
		For J:InRange(J,0,M-1)
		Assign 	X=X0+J*_intmatrixL_+_intmatrixL_/2;

	SmallText(Out R,Out X,Out Y,Out T,Out L,Out Center,V)
		For X0,Y0,N,M:Matrix(X0,Y0,N,M,V)
		For I:InRange(I,0,N-1)
		For J:InRange(J,0,M-1)
		For MatrixItem(I,J,T,L,V)
		Assign 	Y=Y0+(I+1)*_intmatrixH_-_intmatrixH_/2+5 
				X=X0+J*_intmatrixL_+_intmatrixL_/2
				R=_intmatrix_+(I<<16)+J;

	SmallTextColor(R,Out C,V)
		If R!=_intmatrix_-1 && R!=_intmatrix_-2
		Assign R=R-_intmatrix_
		For C: MatrixItemColor(R>>16,R&0x0000FFFF,C,V);

	SmallTextFace(R,Out C,V)
		If R!=_intmatrix_-1 && R!=_intmatrix_-2
		Assign R=R-_intmatrix_
		For C:MatrixItemFace(R>>16,R&0x0000FFFF,C,V);

**/

